package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.CourseService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.CourseDTO;
import cn.rankin.common.utils.dto.search.SearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.product.CourseVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/course")
public class CourseController {

    @Autowired
    private CourseService courseService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<CourseVo>> search(SearchDTO searchDTO) {
        return courseService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<CourseVo> create(@RequestBody CourseDTO courseDTO) {
        return courseService.create(courseDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<CourseVo> update(@RequestBody CourseDTO courseDTO) {
        return courseService.update(courseDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult delete(@PathVariable("id") String id) {
        return courseService.delete(id);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<CourseVo> getCourse(@PathVariable("id") String id) {
        return courseService.getCourse(id);
    }

}
