package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.GroupService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.GroupDTO;
import cn.rankin.common.utils.dto.search.GroupSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.product.GroupVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

@RestController
@RequestMapping(value = "/group")
public class GroupController {

    @Autowired
    private GroupService groupService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<GroupVo>> search(GroupSearchDTO searchDTO) {
        return groupService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<GroupVo> create(@Valid @RequestBody GroupDTO groupDTO) {
        return groupService.create(groupDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<GroupVo> update(@Valid @RequestBody GroupDTO groupDTO) {
        return groupService.update(groupDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {
        return groupService.delete(id);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<GroupVo> getGroup(@PathVariable("id") String id) {
        return groupService.getGroup(id);
    }
}
