package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.SupportService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.SupportDTO;
import cn.rankin.common.utils.dto.search.SearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.product.SupportVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/support")
public class SupportController {

    @Autowired
    private SupportService supportService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<SupportVo>> search(SearchDTO searchDTO) {
        return supportService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<SupportVo> getSupport(@PathVariable("id") String id) {
        return supportService.getSupport(id);
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<SupportVo> create(@RequestBody SupportDTO supportDTO) {
        return supportService.create(supportDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<SupportVo> update(@RequestBody SupportDTO supportDTO) {
        return supportService.update(supportDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult<Boolean> delete(@PathVariable("id") String id) {
        return supportService.delete(id);
    }
}
