package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.CourseDTO;
import cn.rankin.common.utils.vo.product.CourseVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface CourseService {

    @RequestMapping(value = "/course/list", method = RequestMethod.GET)
    APIResult<Page<CourseVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/course", method = RequestMethod.POST)
    APIResult<CourseVo> create(@RequestBody CourseDTO courseDTO);

    @RequestMapping(value = "/course", method = RequestMethod.PUT)
    APIResult<CourseVo> update(@RequestBody CourseDTO courseDTO);

    @RequestMapping(value = "/course/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);

    @RequestMapping(value = "/course/{id}", method = RequestMethod.GET)
    APIResult<CourseVo> getCourse(@PathVariable("id") String id);
}
