package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.SupportDTO;
import cn.rankin.common.utils.vo.product.SupportVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface SupportService {

    @RequestMapping(value = "/support/list", method = RequestMethod.GET)
    APIResult<Page<SupportVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/support/{id}", method = RequestMethod.GET)
    APIResult<SupportVo> getSupport(@PathVariable("id") String id);

    @RequestMapping(value = "/support", method = RequestMethod.POST)
    APIResult<SupportVo> create(@RequestBody SupportDTO supportDTO);

    @RequestMapping(value = "/support", method = RequestMethod.PUT)
    APIResult<SupportVo> update(@RequestBody SupportDTO supportDTO);

    @RequestMapping(value = "/support/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);
}
