package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.user.CampusDTO;
import cn.rankin.common.utils.vo.user.CampusVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.user.name}")
public interface CampusService {

    @RequestMapping(value = "/campus/list", method = RequestMethod.GET)
    APIResult<Page<CampusVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/campus", method = RequestMethod.POST)//, consumes = MediaType.APPLICATION_JSON_VALUE)//, consumes = "application/json")
    APIResult<CampusVo> create(@RequestBody CampusDTO campusDTO);

    @RequestMapping(value = "/campus", method = RequestMethod.PUT)
    APIResult<CampusVo> update(@RequestBody CampusDTO campusDTO);

    @RequestMapping(value = "/campus/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "/campus/{id}", method = RequestMethod.GET)
    APIResult<CampusVo> getCampus(@PathVariable("id") String id);
}
