package cn.rankin.cmsweb.service.user;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.user.MerchantDTO;
import cn.rankin.common.utils.vo.user.MerchantVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.user.name}")
public interface MerchantService {

    @RequestMapping(value = "merchant/list", method = RequestMethod.GET)
    APIResult<Page<MerchantVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "merchant", method = RequestMethod.POST)
    APIResult<MerchantVo> create(@RequestBody MerchantDTO merchantDTO);

    @RequestMapping(value = "merchant", method = RequestMethod.PUT)
    APIResult<MerchantVo> update(@RequestBody MerchantDTO merchantDTO);

    @RequestMapping(value = "merchant/{id}", method = RequestMethod.DELETE)
    APIResult<Boolean> delete(@PathVariable("id") String id);

    @RequestMapping(value = "merchant/{id}", method = RequestMethod.GET)
    APIResult<MerchantVo> getMerchant(@PathVariable("id") String id);

}
