package cn.rankin.common.utils.vo.product;

import cn.rankin.common.utils.enums.ProductTypeEnum;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/*
{
    "code": 200,
    "success": true,
    "message": null,
    "data": {
      'totalNum':300,
      'page':0,
      'pageSize':10
      'recs':[
        {
          'id':'xxx',
          'pid': 'xxx',
          'name':'xxx',
          'code':'xxx',
          'type':'xxx',
          'gmt_modified':1321232,
          'merchantId':'xxxx',
          'goods':[{
            'id':'xxx',
            'duration':2322,
            'chargeUnit':'xxx',
            'cpPrice':12.01,
            'merchantPrice':23.92,
            'terminalPrice':50.1,
            },
            ...
            ],
        }
        ...
      ],
    }
}
 */
@Data
public class ProductVo implements Serializable {

    private String id;

    private String pid;

    private String name;

    private String code;

    private ProductTypeEnum type;

    private String merchantId;

    private Date gmtCreated;

    private Date gmtModified;

}
