package cn.rankin.data.api.product.vo;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.CourseSubTypeEnum;
import cn.rankin.data.api.product.entity.Lesson;
import cn.rankin.data.api.product.entity.Courseware;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
public class CourseSubItemVo implements Serializable{

    private String id;

    private String code;

    private String name;

    private String digest;

    private CourseSubTypeEnum type;

    private BaseStatusEnum status;

    private List<Courseware> coursewareList;

    private Date gmtCreated;

    private Date gmtModified;

    public static CourseSubItemVo parseToVo(Lesson lesson) {
        CourseSubItemVo vo = new CourseSubItemVo();
        BeanUtils.copyProperties(lesson, vo);
        vo.setType(CourseSubTypeEnum.LESSON);
        return vo;
    }
}
