package cn.rankin.productservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.enums.BaseOrderEnum;
import cn.rankin.data.api.product.dto.ProductSearchDTO;
import cn.rankin.data.api.product.entity.Product;
import cn.rankin.productservice.service.ProductService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.LinkedHashMap;

@RestController
@RequestMapping(value = "/product")
public class ProductController {

    @Autowired
    private ProductService productService;

    @RequestMapping(method = RequestMethod.GET)
    public APIResult<Page<Product>> search(ProductSearchDTO searchDTO) {
        Product product = new Product();
        String code = searchDTO.getCode();
        if (!StringUtils.isEmpty(code)) {
            product.setCode(String.format("%" + code + "%"));
        }

        String name = searchDTO.getName();
        if (!StringUtils.isEmpty(name)) {
            product.setName(String.format("%" + name + "%"));
        }

        product.setType(searchDTO.getType());

        LinkedHashMap<String, BaseOrderEnum> sort = new LinkedHashMap<>();
        sort.put("gmtModified", BaseOrderEnum.DESC);

        APIResult<Page<Product>> pageAPIResult = productService.search(product, searchDTO.getPageNo(), searchDTO.getPageSize(), sort);

        return pageAPIResult;
    }

    @RequestMapping(value = "/{productId}", method = RequestMethod.GET)
    public APIResult<Object> getProduct(@PathVariable String productId) {
        return null;
    }
}
