package cn.rankin.productservice.controller;

import cn.rankin.productservice.service.ProductTagRelationService;
import cn.rankin.productservice.service.TagService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Slf4j
@RestController
@RequestMapping(value = "tag")
public class TagController {

    @Autowired
    private TagService tagService;

    @Autowired
    private ProductTagRelationService tagRelationService;
/*
    @Autowired
    private ItemService itemService;

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<Tag> getTag(@PathVariable("id") String id) {
        APIResult<Tag> result = tagService.findById(id);
        Tag tag = result.getData();
        if (tag == null) {
            return result;
        }

        APIResult<List<Item>> itemResult = getTagItem(tag.getId());
        tag.setItemList(itemResult.getData());

        return result;

    }

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<Tag>> search(TagSearchDTO searchDTO) {
        Tag tag = new Tag();

        String name = searchDTO.getName();
        if (name != null) {
            tag.setName("%" + name + "%");
        }

        tag.setMerchantId(searchDTO.getMerchantId());
        tag.setType(searchDTO.getType());

        return tagService.search(tag, searchDTO.getPageNo(), searchDTO.getPageSize());
    }

    @Transactional
    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Tag> create(@RequestBody TagDTO tagDTO) {

        APIResult<Tag> result = tagService.create(tagDTO);
        Tag tag = result.getData();

        List<String> itemIdList = tagDTO.getItemList();
        if (itemIdList == null || tag == null) {
            return result;
        }

        APIResult<List<Item>> relationResult = updateTagRelation(tag, itemIdList);
        if (!relationResult.getSuccess()) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return APIResult.error(new BaseCode(relationResult.getCode(), relationResult.getMessage()));
        }
        tag.setItemList(relationResult.getData());

        return result;

    }

    @Transactional
    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<Tag> update(@RequestBody TagDTO tagDTO) {
        if (tagDTO.getId() == null) {
            return APIResult.error(APICode.PARAMETER_ERROR);
        }

        APIResult<Tag> result = tagService.update(tagDTO);
        Tag tag = result.getData();

        List<String> itemIdList = tagDTO.getItemList();
        if (itemIdList == null || tag == null) {
            return result;
        }

        APIResult<List<Item>> relationResult = updateTagRelation(tag, itemIdList);
        if (!relationResult.getSuccess()) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return APIResult.error(new BaseCode(relationResult.getCode(), relationResult.getMessage()));
        }
        tag.setItemList(relationResult.getData());

        return tagService.update(tagDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult delete(@PathVariable("id") String id) {
        if (StringUtils.isEmpty(id)) {
            return APIResult.error(APICode.PARAMETER_ERROR);
        }

        List<ProductTagRelation> relationList = tagRelationService.findAllByTagId(id);
        if (CollectionUtils.isEmpty(relationList)) {
            return tagService.delete(id);
        }

        List<String> itemIdList = new ArrayList<>();
        relationList.forEach( relation -> {
            String itemId = relation.getItemId();
            if (itemId != null && !itemIdList.contains(itemId)) {
                itemIdList.add(itemId);
            }
        });

        List<Item> itemList = itemService.findAllByIds(itemIdList).getData();

        APIResult<List<Item>> result = APIResult.error(APICode.CAN_NOT_DEL);
        result.setData(itemList);

        return result;
    }

    @Transactional
    public APIResult<List<Item>> updateTagRelation(Tag tag, List<String> itemIdList) {
        List<Item> itemList = itemService.findAllByIds(itemIdList).getData();
        if (itemList == null || itemList.size() != itemIdList.size()) {
            return APIResult.error(APICode.error("itemId不匹配"));
        }

        TagTypeEnum tagType = tag.getType();
        String merchantId = tag.getMerchantId();
        for (int i = 0; i < itemList.size(); i++) {
            Item item = itemList.get(i);
            if (!item.getMerchantId().equals(merchantId) || !EnumUtil.compare(item.getType(), tagType)) {
                return APIResult.error(APICode.error("类型或渠道商不匹配"));
            }
        }

        tagRelationService.updateByTag(tag.getId(), itemIdList);
        return APIResult.ok(itemList);
    }

    public APIResult<List<Item>> getTagItem(String tagId) {
        List<ProductTagRelation> relationList = tagRelationService.findByTagId(tagId);
        if (relationList == null || relationList.size() == 0) {
            return APIResult.ok();
        }

        List<String> itemIdList = new ArrayList<>();
        relationList.forEach( relation -> itemIdList.add(relation.getItemId()));

        // 返回上架的item
        return itemService.findAllByIds(itemIdList, ItemStatusEnum.DEL);

    }
    */
}
