package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Course;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface CourseRepository extends BasicJpaRepository<Course, String> {

    Long countByCode(String code);

    Course findById(String id);

    @Query(value = "select c from Course c where c.id in (:ids) and c.status = :status")
    List<Course> findByIdIn(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);

    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(value = "update Course c set c.status = :status where c.id = :id")
    Integer deleteById(@Param("id") String id, @Param("status") BaseStatusEnum status);
}
