package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.TagGroup;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

public interface TagGroupRepository extends BasicJpaRepository<TagGroup, String> {

    Long countByCode(String code);

    @Query(value = "select g from TagGroup g where g.id = :id and g.status = :status")
    TagGroup findNormalById(@Param("id") String id, @Param("status") BaseStatusEnum status);

    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(value = "update TagGroup g set g.status = :status where g.id = :id")
    Integer deleteById(@Param("id") String id, @Param("status")BaseStatusEnum status);
}
