package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.TagTypeEnum;
import cn.rankin.data.api.product.entity.Tag;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

@Repository
public class TagRepositoryImpl {

    @PersistenceContext
    private EntityManager entityManager;

    List<Tag> search(Tag tag, Integer start, Integer size) {
        StringBuilder builder = new StringBuilder(TagRepository.SQL);

        String name = tag.getName();
        if (name != null) {
            builder.append(String.format(" and t.name like '%s'", name));
        }

        String merchantId = tag.getMerchantId();
        if (merchantId != null) {
            builder.append(String.format(" and g.merchantId = %s", merchantId));
        }

        TagTypeEnum type = tag.getType();
        if (type != null) {
            builder.append(" and t.type = :type");
        }

        builder.append(" order by t.gmtModified desc");

        Query query = entityManager.createQuery(builder.toString());
        if (type != null) {
            query.setParameter("type", type);
        }

        query.setFirstResult(start);
        query.setMaxResults(size);

        return query.getResultList();
    }
}
