package cn.rankin.productservice.service;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.enums.BaseOrderEnum;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import cn.rankin.common.utils.util.JpaSortUtil;
import cn.rankin.data.api.product.entity.Product;
import cn.rankin.productservice.code.ProductServiceAPICode;
import cn.rankin.productservice.repository.ProductRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.LinkedHashMap;
import java.util.List;

@Service
public class ProductService {

    @Autowired
    private ProductRepository productRepository;

    public APIResult<Page<Product>> search(Product product, Integer pageNo, Integer pageSize, LinkedHashMap<String, BaseOrderEnum> sort) {
        Long count = productRepository.count(product);
        Page<Product> page = new Page<>(count, pageNo, pageSize);

        Long start = page.getStart();
        if (count <= start) {
            return APIResult.ok(page);
        }

        List<Product> productList = productRepository.find(product, start, page.getPageSize(), JpaSortUtil.sort(sort));
        page.setList(productList);

        return APIResult.ok(page);
    }

    public APIResult<Object> getProduct(String productId) {
        Product product = productRepository.findByPid(productId);
        if (product == null) {
            return APIResult.error(ProductServiceAPICode.NOT_EXISTS);
        }

        ProductTypeEnum type = product.getType();
        if (ProductTypeEnum.COURSE.equals(type)) {
        }
        return null
    }

}
