package cn.rankin.productservice.utils;

import cn.rankin.common.utils.enums.CourseSubTypeEnum;
import cn.rankin.data.api.product.dto.*;
import cn.rankin.data.api.product.entity.*;
import cn.rankin.data.api.product.vo.CourseSubItemVo;
import org.springframework.beans.BeanUtils;

public class DTOConverter {

    // CourseDTO to Course
    public static Course convert(CourseDTO courseDTO) {
        Course course = new Course();
        BeanUtils.copyProperties(courseDTO, course);

        return course;
    }

    // WareDTO to Ware
    public static Courseware convert(WareDTO wareDTO) {
        Courseware Courseware = new Courseware();
        BeanUtils.copyProperties(wareDTO, Courseware);
        return Courseware;
    }

    // SupportDTO to Support
    public static Support convert(SupportDTO supportDTO) {
        Support support = new Support();
        BeanUtils.copyProperties(supportDTO, support);
        return support;
    }

    // LessonDTO to Lesson
    public static Lesson convert(LessonDTO lessonDTO) {
        Lesson lesson = new Lesson();
        BeanUtils.copyProperties(lessonDTO, lesson);

        return lesson;
    }

    // Lesson to CourseSubItemVo
    public static CourseSubItemVo convert(Lesson lesson) {
        CourseSubItemVo subItemVo = new CourseSubItemVo();
        BeanUtils.copyProperties(lesson, subItemVo);
        subItemVo.setType(CourseSubTypeEnum.LESSON);

        return subItemVo;
    }

    // CourseSubRelationDTO convert CourseSubRelation
    public static CourseSubRelation convert(String courseId, CourseSubRelationDTO courseSubRelationDTO) {
        CourseSubRelation relation = new CourseSubRelation();
        relation.setCourseId(courseId);
        relation.setSubId(courseSubRelationDTO.getId());
        relation.setType(courseSubRelationDTO.getType());

        return relation;
    }

    public static TagGroup convert(GroupDTO groupDTO) {
        TagGroup tagGroup = new TagGroup();
        BeanUtils.copyProperties(groupDTO, tagGroup);
        return tagGroup;
    }

    public static Tag convert(TagDTO tagDTO) {
        Tag tag = new Tag();
        BeanUtils.copyProperties(tagDTO, tag);
        return tag;
    }
}
