package cn.rankin.userservice.utils;

import cn.rankin.common.utils.dto.user.CampusDTO;
import cn.rankin.common.utils.dto.user.CmsUserDTO;
import cn.rankin.common.utils.dto.user.MerchantDTO;
import cn.rankin.common.utils.dto.user.TerminalUserDTO;
import cn.rankin.common.utils.util.SecurityUtil;
import cn.rankin.userservice.dto.UserRegistry;
import cn.rankin.userservice.entity.Campus;
import cn.rankin.userservice.entity.CmsUser;
import cn.rankin.userservice.entity.Merchant;
import cn.rankin.userservice.entity.TerminalUser;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;

public class DTOConverter {

    public static Merchant convert(MerchantDTO merchantDTO) {
        Merchant merchant = new Merchant();
        BeanUtils.copyProperties(merchantDTO, merchant);
        return merchant;
    }

    public static CmsUser convert(CmsUserDTO userDTO) {
        CmsUser user = new CmsUser();
        BeanUtils.copyProperties(userDTO, user);
        return user;
    }

    public static Campus convert(CampusDTO campusDTO) {
        Campus campus = new Campus();
        BeanUtils.copyProperties(campusDTO, campus);
        campus.setName();
        return campus;
    }

    public static TerminalUser convert(TerminalUserDTO terminalUserDTO) {
        TerminalUser terminalUser = new TerminalUser();
        BeanUtils.copyProperties(terminalUserDTO, terminalUser);
        return terminalUser;
    }

    public static UserRegistry convert(TerminalUser terminalUser) {
        UserRegistry userRegistry = new UserRegistry();
        userRegistry.setEntry(terminalUser.getCode());
        userRegistry.setEntryType(Constant.EntryType.EID);
        userRegistry.setPasswd(terminalUser.getPassword());
        return userRegistry;
    }
}
